import java.util.Iterator;

public class CircularBuffer<A> implements BoundedQueue<A> {
  private CircularBoundedBuffer<A> q;

  CircularBuffer() {
    q = new CircularBoundedBuffer<A>(2);
  }

  @Override
  public void enqueue(A x) {
    if (q.full()) increaseBufferSize();

    q.enqueue(x);
  }

  private void increaseBufferSize() {
    CircularBoundedBuffer<A> r = new CircularBoundedBuffer<A>(q.capacity() * 2);

    while (!q.empty())
      r.enqueue(q.dequeue());

    q = r;
  }

  @Override
  public A dequeue() {
    return q.dequeue();
  }

  @Override
  public Boolean empty() {
    return q.empty();
  }

  @Override
  public int capacity() {
    return q.capacity();
  }

  @Override
  public Iterator<A> iterator() {
    return q.iterator();
  }
}
